/*****************************************************************

	Sender.java:    Program which sends messages to agents  
	------------     to agents whose local names are "a1" and "a2"
	
    Author:  Jean Vaucher
    Date:    Aug 10 2003 
    
  Test1:  % java jade.Boot main:Sender a1:Receiver a2:Pong
  
  Test2: with "a1" and "a2" in a different container
  
  	    %java jade.Boot a1:Receiver a2:Pong 
  	
   and in another window do:

  	    %java jade.Boot -container main:Sender
	
*****************************************************************/


import jade.core.Agent;
import jade.core.AID;
import jade.core.behaviours.*;

//import jade.domain.AMSService;
//import jade.domain.FIPAAgentManagement.*;

import jade.lang.acl.*;


public class Sender extends Agent 
{
    protected void setup() 
    {
	// First set-up answering behaviour
	
		addBehaviour(new CyclicBehaviour(this) 
		{
			 public void action() {
				ACLMessage msg= receive();
				if (msg!=null)
					System.out.println( "== Answer" + " <- " 
					 +  msg.getContent() + " from "
					 +  msg.getSender().getName() );
				block();
			 }
		});
		
	// Send messages to "a1" and "a2"
	
		ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
		msg.setContent( "Ping" );
     	for (int i = 1; i<=2; i++)
        	msg.addReceiver( new AID( "a" + i, AID.ISLOCALNAME) );

		send(msg);
		
	}
}
